config/routes.rb
Rails.application.routes.draw do
  resources :articles
  resources :categories
  resources :vats
  resources :projects
  resources :users
  resources :interventions
  resources :partners

  root 'partners#index'

  resource :user_sessions, only: [:create, :new, :destroy]

  get 'logout' => 'user_sessions#destroy', :as => :logout

  get 'login' => 'user_sessions#login', :as => :login

  post 'get_token' => 'user_sessions#get_token'

  get 'partners/:id/interventions' => 'partners#interventions'

	get 'partners/:id/projects' => 'partners#projects'

  get 'users/:id/interventions' => 'users#interventions'

  get 'config/' => 'config#index'

  get 'about/' => 'about#index'

end

app/models/category.rb
class Category < ActiveRecord::Base
  belongs_to :sale_vat, :class_name => "Vat"
  belongs_to :purchase_vat, :class_name => "Vat"
end

app/controllers/categories_controller.rb
class CategoriesController < ApplicationController
  before_action :set_category, only: [:edit, :update, :destroy]
  before_action :set_vats, only: [:edit, :new]
  # GET /categories
  # GET /categories.json
  def index
    @categories = Category.all
  end

  # GET /categories/1
  # GET /categories/1.json
  #def show
  #end

  # GET /categories/new
  def new
    @category = Category.new
  end

  # GET /categories/1/edit
  def edit
  end

  # POST /categories
  # POST /categories.json
  def create
    @category = Category.new(category_params)

    respond_to do |format|
      if @category.save
        format.html { redirect_to categories_path, notice: 'Category was successfully created.' }
        format.json { render :show, status: :created, location: @category }
      else
        format.html { render :new }
        format.json { render json: @category.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /categories/1
  # PATCH/PUT /categories/1.json
  def update
    respond_to do |format|
      if @category.update(category_params)
        format.html { redirect_to categories_path, notice: 'Category was successfully updated.' }
        format.json { render :show, status: :ok, location: @category }
      else
        format.html { render :edit }
        format.json { render json: @category.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /categories/1
  # DELETE /categories/1.json
  def destroy
    @category.destroy
    respond_to do |format|
      format.html { redirect_to categories_url, notice: 'Category was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_category
      @category = Category.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def category_params
      params.require(:category).permit(:title, :sale_vat_id, :purchase_vat_id)
    end
    def set_vats
      @vats = Vat.order(:title)
    end
end

app/helpers/categories_helper.rb
module CategoriesHelper
end

app/views/categories/_form.html.erb
<%= form_for(@category) do |f| %>
  <% if @category.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@category.errors.count, "error") %> prohibited this category from being saved:</h2>

      <ul>
      <% @category.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="titre_actif">

    <h1><%= f.text_field :title , placeholder: "Nouvelle categorie "%></h1>
    <span class="title-tag">
      <i class="fa fa-gear fa-4x"></i>
    </span>
  </div>


  <div class="tab-pane" id="tab_compta">
    <div class="well left">
     <p>
        <strong>Taux de Tva à la vente:</strong>
          <%= f.select(:sale_vat_id , [], {}, class: "form-control" ) do %>
            <% @vats.each do |vat| %>
              <%= content_tag(:option, vat.title, value: vat.id, selected: (vat.id==@category.sale_vat_id)) %>
            <% end %>
          <% end %>
      </p>

      <p>
        <strong>Taux de Tva à l'achat:</strong>

        <%= f.select(:purchase_vat_id , [], {}, class: "form-control" ) do %>
          <% @vats.each do |vat| %>
            <%= content_tag(:option, vat.title, value: vat.id, selected: (vat.id==@category.purchase_vat_id)) %>
          <% end %>
        <% end %>
      </p>
    </div>
  </div>

  <div class="actions">
    <%= f.submit "Valider", class: "btn btn-primary" %> ou
    <%= link_to 'Retour', categories_path %>
  </div>
<% end %>

app/views/categories/edit.html.erb
<%= render 'form' %>

app/views/categories/index.html.erb
<div class="titre_actif">
  <div class="toolbar">
    <%= link_to new_category_path, class: "btn btn-primary" do %>
      <i class="fa fa-plus fa-3x"></i>
    <% end %>
  </div>
  <h1>Categories</h1>
  <span class="title-tag">
    <i class="fa fa-gear fa-4x"></i>
  </span>
</div>

<table id="table"
     data-classes="table table-hover table-condensed"
     data-striped="true"
     data-toolbar="#toolbar"
     data-pagination="true"
     data-click-to-select="false"
     data-search="true"
     data-show-export="true"
     data-reorderable-columns="true"
     data-show-refresh="true"
     data-show-pagination-switch="true">
  <thead>
    <tr>
      <th>titre</th>
      <th>Tva à  la vente</th>
      <th>Tva à l'achat</th>
      <th></th>
    </tr>
  </thead>

  <tbody>
    <% @categories.each do |category| %>
      <tr>
        <td>
          <%= category.title %>
          <span class="cell-icon">
            <a href="<%= edit_category_path(category) %>"><i class="fa fa-external-link"></i></a>
          </span>
        </td>
        <td><%= category.sale_vat.title %></td>
        <td><%= category.purchase_vat.title %></td>
        <td>
          <%= link_to category, method: :delete, data: { confirm: 'Etes-vous sûr de vouloir supprimer cette feuille ?' } do %>
            <i class="fa fa-trash fa-fw"></i>
          <% end %>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/categories/new.html.erb
<%= render 'form' %>

app/views/categories/show.html.erb
<div class="titre_actif">
  <div class="toolbar">
    <%= link_to edit_category_path(@category) , class: "btn btn-primary" do %>
      <i class="fa fa-pencil fa-3x"></i>
    <% end %>
  </div>
  <h1><%=  @category.title %></h1>
  <span class="title-tag">
    <i class="fa fa-archive fa-4x"></i>
  </span>
</div>


<p>
  <strong>T Tva à la vente:</strong>
  <%= @category.sale_vat.title %>
</p>

<p>
  <strong> Tva à l'achat:</strong>
  <%= @category.purchase_vat.title %>
</p>